## spectral 0.0~2019.11.12+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(IDENTIFIER "org.eu.encom.spectral")
set(COPYRIGHT "Copyright © 2018-2019 bhat@encom.eu.org")

project(spectral VERSION 0.0.0 LANGUAGES CXX)

if(UNIX AND NOT APPLE)
    set(LINUX 1)
endif(UNIX AND NOT APPLE)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
    include(cmake/ECMInstallIcons.cmake)
endif(NOT WIN32)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

set(CMAKE_CXX_STANDARD 17)

# Setup command line parameters for the compiler and linker
foreach (FLAG "" all pedantic extra no-unused-parameter)
    CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
    if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W${FLAG}")
    endif ()
endforeach ()

# Find the libraries
find_package(Qt5 5.12 REQUIRED Widgets Network Quick Qml Gui Svg Multimedia QuickControls2)
if(LINUX)
    find_package(Qt5DBus REQUIRED)
endif(LINUX)
if (APPLE)
    find_package(Qt5MacExtras REQUIRED)
endif(APPLE)
# Qt5_Prefix is only used to show Qt path in message()
# Qt5_BinDir is where all the binary tools for Qt are
if (QT_QMAKE_EXECUTABLE)
    get_filename_component(Qt5_BinDir "${QT_QMAKE_EXECUTABLE}" DIRECTORY)
    get_filename_component(Qt5_Prefix "${Qt5_BinDir}/.." ABSOLUTE)
else()
    get_filename_component(Qt5_BinDir "${Qt5_DIR}/../../../bin" ABSOLUTE)
    get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
endif()

# prevent error "You must build your code with position independent code if Qt was built with..
if (Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

set(QML_IMPORT_PATH ${CMAKE_SOURCE_DIR}/qml ${CMAKE_SOURCE_DIR}/imports CACHE string "" FORCE)

if(WIN32)
    enable_language(RC)
    include(CMakeDetermineRCCompiler)
endif()

if ((NOT DEFINED USE_INTREE_LIBQMC OR USE_INTREE_LIBQMC)
        AND EXISTS ${PROJECT_SOURCE_DIR}/include/libQuotient/lib/util.h)
    add_subdirectory(include/libQuotient EXCLUDE_FROM_ALL)
    include_directories(include/libQuotient)
    if (NOT DEFINED USE_INTREE_LIBQMC)
        set (USE_INTREE_LIBQMC 1)
    endif ()
endif ()
if (NOT USE_INTREE_LIBQMC)
    find_package(Quotient 0.6 REQUIRED)
    if (NOT Quotient_FOUND)
        message( WARNING "libQuotient not found; configuration will most likely fail.")
    endif ()
endif ()

find_package(Qt5Keychain REQUIRED)

find_package(cmark REQUIRED)

add_subdirectory(include/SortFilterProxyModel EXCLUDE_FROM_ALL)

message( STATUS )
message( STATUS "=============================================================================" )
message( STATUS "                          Spectral Build Information" )
message( STATUS "=============================================================================" )
if (CMAKE_BUILD_TYPE)
    message( STATUS "Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "Spectral install prefix: ${CMAKE_INSTALL_PREFIX}" )
# Get Git info if possible
find_package(Git)
if(GIT_FOUND)
    execute_process(COMMAND
        "${GIT_EXECUTABLE}" rev-parse -q HEAD
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        OUTPUT_VARIABLE GIT_SHA1
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    message( STATUS "Git SHA1: ${GIT_SHA1}")
endif()
message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
if (USE_INTREE_LIBQMC)
    message( STATUS "Using in-tree libQuotient")
    if (GIT_FOUND)
        execute_process(COMMAND
            "${GIT_EXECUTABLE}" rev-parse -q HEAD
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/libQuotient
            OUTPUT_VARIABLE LIB_GIT_SHA1
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        message( STATUS "  Library git SHA1: ${LIB_GIT_SHA1}")
    endif (GIT_FOUND)
else ()
    message( STATUS "Using libQuotient ${Quotient_VERSION} at ${Quotient_DIR}")
endif ()

message( STATUS "=============================================================================" )
message( STATUS )

# Set up source files
set(spectral_SRCS
    src/notifications/manager.h
    src/accountlistmodel.h
    src/controller.h
    src/emojimodel.h
    src/imageclipboard.h
    src/matriximageprovider.h
    src/messageeventmodel.h
    src/roomlistmodel.h
    src/spectralroom.h
    src/spectraluser.h
    src/trayicon.h
    src/userlistmodel.h
    src/utils.h
    src/accountlistmodel.cpp
    src/controller.cpp
    src/emojimodel.cpp
    src/imageclipboard.cpp
    src/matriximageprovider.cpp
    src/messageeventmodel.cpp
    src/roomlistmodel.cpp
    src/spectralroom.cpp
    src/spectraluser.cpp
    src/trayicon.cpp
    src/userlistmodel.cpp
    src/utils.cpp
    src/main.cpp
)

if (APPLE)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -framework Foundation -framework Cocoa")
    set(spectral_SRCS ${spectral_SRCS} src/notifications/managermac.mm)
elseif (WIN32)
    set(spectral_SRCS ${spectral_SRCS} src/notifications/managerwin.cpp src/notifications/wintoastlib.cpp)
else ()
    set(spectral_SRCS ${spectral_SRCS} src/notifications/managerlinux.cpp)
endif ()

set(spectral_QRC
    res.qrc
)

QT5_ADD_RESOURCES(spectral_QRC_SRC ${spectral_QRC})
set_property(SOURCE qrc_resources.cpp PROPERTY SKIP_AUTOMOC ON)

if(WIN32)
    set(spectral_WINRC spectral_win32.rc)
    set_property(SOURCE spectral_win32.rc APPEND PROPERTY
        OBJECT_DEPENDS ${PROJECT_SOURCE_DIR}/icons/icon.ico
    )
endif()

if(APPLE)
    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
    set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})

    set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})

    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${spectral_VERSION})
    set(MACOSX_BUNDLE_BUNDLE_VERSION ${spectral_VERSION})

    set(ICON_NAME "icon.icns")
    set(${PROJECT_NAME}_MAC_ICON "${PROJECT_SOURCE_DIR}/icons/${ICON_NAME}")
    set(MACOSX_BUNDLE_ICON_FILE ${ICON_NAME})
    set_property(SOURCE "${${PROJECT_NAME}_MAC_ICON}" PROPERTY
        MACOSX_PACKAGE_LOCATION Resources)
endif(APPLE)

# Windows, this is a GUI executable; OSX, make a bundle
add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE
    ${spectral_SRCS} ${spectral_QRC_SRC} $<TARGET_OBJECTS:SortFilterProxyModel>
    ${spectral_WINRC} ${${PROJECT_NAME}_MAC_ICON})

target_link_libraries(${PROJECT_NAME}
    Qt5::Widgets Qt5::Quick Qt5::Qml Qt5::Gui Qt5::Network Qt5::Svg Qt5::QuickControls2
    Quotient
    cmark::cmark
    ${QTKEYCHAIN_LIBRARIES}
    )
target_compile_definitions(${PROJECT_NAME} PRIVATE
    GIT_SHA1="${GIT_SHA1}" LIB_GIT_SHA1="${LIB_GIT_SHA1}")

if (APPLE)
    target_link_libraries(${PROJECT_NAME} Qt5::MacExtras)
elseif(LINUX)
    target_link_libraries(${PROJECT_NAME} Qt5::DBus)
endif()

# macOS specific config for bundling
set_property(TARGET ${PROJECT_NAME} PROPERTY
    MACOSX_BUNDLE_INFO_PLIST "${PROJECT_SOURCE_DIR}/macOS/Info.plist.in")

# Installation

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR ".")
endif()

install(TARGETS ${PROJECT_NAME}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        BUNDLE DESTINATION ${CMAKE_INSTALL_BINDIR})
if(LINUX)
    install(FILES linux/${IDENTIFIER}.desktop
            DESTINATION  ${CMAKE_INSTALL_DATADIR}/applications
            )
    install(FILES linux/${IDENTIFIER}.appdata.xml
            DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
            )
    file(GLOB spectral_icons icons/hicolor/*-apps-spectral.png)
    ecm_install_icons(ICONS ${spectral_icons}
                      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
                      )
endif(LINUX)

=== include/SortFilterProxyModel/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(CMAKE_CXX_STANDARD 11)

find_package(Qt5 REQUIRED
    Core
    Qml
    )

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON) # This is to find generated *.moc and *.h files in build dir

add_library(SortFilterProxyModel OBJECT
    qqmlsortfilterproxymodel.cpp
    filters/filter.cpp
    filters/filtercontainer.cpp
    filters/rolefilter.cpp
    filters/valuefilter.cpp
    filters/indexfilter.cpp
    filters/regexpfilter.cpp
    filters/rangefilter.cpp
    filters/expressionfilter.cpp
    filters/filtercontainerfilter.cpp
    filters/anyoffilter.cpp
    filters/alloffilter.cpp
    filters/filtersqmltypes.cpp
    sorters/sorter.cpp
    sorters/sortercontainer.cpp
    sorters/rolesorter.cpp
    sorters/stringsorter.cpp
    sorters/expressionsorter.cpp
    sorters/sortersqmltypes.cpp
    proxyroles/proxyrole.cpp
    proxyroles/proxyrolecontainer.cpp
    proxyroles/joinrole.cpp
    proxyroles/switchrole.cpp
    proxyroles/expressionrole.cpp
    proxyroles/proxyrolesqmltypes.cpp   
    proxyroles/singlerole.cpp   
    proxyroles/regexprole.cpp
    sorters/filtersorter.cpp
    proxyroles/filterrole.cpp
    )

target_include_directories(SortFilterProxyModel PUBLIC
    ${CMAKE_CURRENT_LIST_DIR}
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt5::Qml,INTERFACE_INCLUDE_DIRECTORIES>
    )

=== include/libQuotient/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
if (POLICY CMP0092)
cmake_policy(SET CMP0092 NEW)
endif()

set(API_VERSION "0.6")
project(Quotient VERSION "${API_VERSION}.0" LANGUAGES CXX)

option(QUOTIENT_INSTALL_EXAMPLE "install qmc-example application" ON)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
endif(NOT WIN32)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
    set(CMAKE_INSTALL_LIBDIR ".")
endif()

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR ".")
endif()

if (NOT CMAKE_INSTALL_INCLUDEDIR)
    set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

if (MSVC)
    add_compile_options(/EHsc /W4
        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027)
else()
    foreach (FLAG all "" pedantic extra error=return-type no-unused-parameter
                  no-gnu-zero-variadic-macro-arguments)
        CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
        if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
            add_compile_options(-W${FLAG})
        endif ()
    endforeach ()
endif()

find_package(Qt5 5.9 REQUIRED Network Gui Multimedia)
get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)

if ((NOT DEFINED USE_INTREE_LIBQOLM OR USE_INTREE_LIBQOLM)
        AND EXISTS ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm/lib/utils.h)
    add_subdirectory(3rdparty/libQtOlm EXCLUDE_FROM_ALL)
    include_directories(3rdparty/libQtOlm)
    if (NOT DEFINED USE_INTREE_LIBQOLM)
        set (USE_INTREE_LIBQOLM 1)
    endif ()
endif ()
if (NOT USE_INTREE_LIBQOLM)
    find_package(QtOlm 0.1.0 REQUIRED)
    if (NOT QtOlm_FOUND)
        message( WARNING "libQtOlm not found; configuration will most likely fail.")
        message( WARNING "Make sure you have installed libQtOlm development files")
        message( WARNING "as a package or checked out the library sources in lib/.")
        message( WARNING "See also BUILDING.md")
    endif ()
endif ()

if (GTAD_PATH)
    get_filename_component(ABS_GTAD_PATH "${GTAD_PATH}" REALPATH)
endif ()
if (MATRIX_DOC_PATH)
    get_filename_component(ABS_API_DEF_PATH "${MATRIX_DOC_PATH}/api" REALPATH)
endif ()
if (ABS_GTAD_PATH AND ABS_API_DEF_PATH)
    if (NOT CLANG_FORMAT)
        set(CLANG_FORMAT clang-format)
    endif()
    get_filename_component(ABS_CLANG_FORMAT "${CLANG_FORMAT}" PROGRAM)
endif()

message( STATUS )
message( STATUS "=============================================================================" )
message( STATUS "                       ${PROJECT_NAME} Build Information" )
message( STATUS "=============================================================================" )
message( STATUS "Version: ${PROJECT_VERSION}, API version: ${API_VERSION}")
if (CMAKE_BUILD_TYPE)
    message( STATUS "Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "Install Prefix: ${CMAKE_INSTALL_PREFIX}" )
message( STATUS "Using Qt ${Qt5_VERSION} at ${Qt5_Prefix}" )
if (ABS_API_DEF_PATH AND ABS_GTAD_PATH)
    message( STATUS "Generating API stubs enabled (use --target update-api)" )
    message( STATUS "  Using GTAD at ${ABS_GTAD_PATH}" )
    message( STATUS "  Using API files at ${ABS_API_DEF_PATH}" )
    if (ABS_CLANG_FORMAT)
        message( STATUS "clang-format is at ${ABS_CLANG_FORMAT}")
    else ()
        message( STATUS "${CLANG_FORMAT} is NOT FOUND; API files won't be reformatted")
    endif ()
endif ()
find_package(Git)
if (USE_INTREE_LIBQOLM)
    message( STATUS "Using in-tree libQtOlm")
    if (GIT_FOUND)
        execute_process(COMMAND
            "${GIT_EXECUTABLE}" rev-parse -q HEAD
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm
            OUTPUT_VARIABLE QTOLM_GIT_SHA1
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        message( STATUS "  Library git SHA1: ${QTOLM_GIT_SHA1}")
    endif (GIT_FOUND)
else ()
    message( STATUS "Using libQtOlm ${QtOlm_VERSION} at ${QtOlm_DIR}")
endif ()
message( STATUS "=============================================================================" )
message( STATUS )

# Set up source files
set(lib_SRCS
    lib/networkaccessmanager.cpp
    lib/connectiondata.cpp
    lib/connection.cpp
    lib/logging.cpp
    lib/room.cpp
    lib/user.cpp
    lib/avatar.cpp
    lib/syncdata.cpp
    lib/settings.cpp
    lib/networksettings.cpp
    lib/converters.cpp
    lib/util.cpp
    lib/encryptionmanager.cpp
    lib/eventitem.cpp
    lib/events/event.cpp
    lib/events/roomevent.cpp
    lib/events/stateevent.cpp
    lib/events/eventcontent.cpp
    lib/events/roomcreateevent.cpp
    lib/events/roomtombstoneevent.cpp
    lib/events/roommessageevent.cpp
    lib/events/roommemberevent.cpp
    lib/events/typingevent.cpp
    lib/events/receiptevent.cpp
    lib/events/reactionevent.cpp
    lib/events/callanswerevent.cpp
    lib/events/callcandidatesevent.cpp
    lib/events/callhangupevent.cpp
    lib/events/callinviteevent.cpp
    lib/events/directchatevent.cpp
    lib/events/encryptionevent.cpp
    lib/events/encryptedevent.cpp
    lib/jobs/requestdata.cpp
    lib/jobs/basejob.cpp
    lib/jobs/syncjob.cpp
    lib/jobs/mediathumbnailjob.cpp
    lib/jobs/downloadfilejob.cpp
)

set(CSAPI_DIR csapi)
set(ASAPI_DEF_DIR application-service/definitions)
set(ISAPI_DEF_DIR identity/definitions)

foreach (D ${CSAPI_DIR} ${CSAPI_DIR}/definitions
         ${CSAPI_DIR}/definitions/wellknown ${ASAPI_DEF_DIR} ${ISAPI_DEF_DIR})
    aux_source_directory(lib/${D} api_SRCS)
endforeach()

# Make no mistake: CMake cannot run gtad first and then populate the list of
# resulting api_SRCS files. In other words, placing the above foreach after
# the custom targets definition won't bring the desired result:
# CMake will execute it at cmake invocation and gtad will only run later
# when building the update-api target. If you see that gtad has created
# new files you have to re-run cmake.
# TODO: check `file(GLOB_RECURSE ... CONFIGURE_DEPENDS)` (from CMake 3.14)
if (MATRIX_DOC_PATH AND GTAD_PATH)
    set(FULL_CSAPI_DIR lib/${CSAPI_DIR})
    set(FULL_CSAPI_SRC_DIR ${ABS_API_DEF_PATH}/client-server)
    file(GLOB_RECURSE API_DEFS RELATIVE ${PROJECT_SOURCE_DIR}
        ${FULL_CSAPI_SRC_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ASAPI_DEF_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ISAPI_DEF_DIR}/*.yaml
    )
    add_custom_target(update-api
        ${ABS_GTAD_PATH} --config ${CSAPI_DIR}/gtad.yaml --out ${CSAPI_DIR}
            ${FULL_CSAPI_SRC_DIR}
            old_sync.yaml- room_initial_sync.yaml- # deprecated
            sync.yaml- # we have a better handcrafted implementation
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/lib
        SOURCES ${FULL_CSAPI_DIR}/gtad.yaml
                ${FULL_CSAPI_DIR}/{{base}}.h.mustache
                ${FULL_CSAPI_DIR}/{{base}}.cpp.mustache
                ${API_DEFS}
        VERBATIM
    )
    if (ABS_CLANG_FORMAT)
        # TODO: list(TRANSFORM) is available from CMake 3.12
        foreach (S ${api_SRCS})
            string (REGEX REPLACE ".cpp$" ".h" H ${S})
            list(APPEND api_HDRS ${H})
        endforeach()
        set(CLANG_FORMAT_ARGS -i -sort-includes ${CLANG_FORMAT_ARGS})
        add_custom_command(TARGET update-api POST_BUILD
            COMMAND ${ABS_CLANG_FORMAT} ${CLANG_FORMAT_ARGS} ${api_SRCS}
            COMMAND ${ABS_CLANG_FORMAT} ${CLANG_FORMAT_ARGS} ${api_HDRS}
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            VERBATIM
            COMMENT Formatting files
        )
    endif()
endif()

set(example_SRCS examples/qmc-example.cpp)

add_library(${PROJECT_NAME} ${lib_SRCS} ${api_SRCS})
set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION "${PROJECT_VERSION}"
    SOVERSION ${API_VERSION}
    INTERFACE_${PROJECT_NAME}_MAJOR_VERSION ${API_VERSION}
)
set_property(TARGET ${PROJECT_NAME} APPEND PROPERTY
             COMPATIBLE_INTERFACE_STRING ${PROJECT_NAME}_MAJOR_VERSION)

target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_17)

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
target_link_libraries(${PROJECT_NAME} QtOlm Qt5::Core Qt5::Network Qt5::Gui Qt5::Multimedia)

add_executable(qmc-example ${example_SRCS})
target_link_libraries(qmc-example Qt5::Core Quotient)
configure_file(Quotient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Quotient.pc @ONLY NEWLINE_STYLE UNIX)

# Installation

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
install(DIRECTORY lib/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.h")

include(CMakePackageConfigHelpers)
# NB: SameMajorVersion doesn't really work yet, as we're within 0.x trail.
# Maybe consider jumping the gun and releasing 1.0, as semver advises?
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
)

export(PACKAGE ${PROJECT_NAME})
export(EXPORT ${PROJECT_NAME}Targets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Targets.cmake")
configure_file(cmake/QuotientConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfig.cmake"
    COPYONLY
)

set(ConfigFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
install(EXPORT ${PROJECT_NAME}Targets
        FILE ${PROJECT_NAME}Targets.cmake DESTINATION ${ConfigFilesLocation})

install(FILES cmake/QuotientConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfigVersion.cmake"
    DESTINATION ${ConfigFilesLocation}
)
install(EXPORT_ANDROID_MK QuotientTargets DESTINATION share/ndk-modules)

if (WIN32)
    install(FILES mime/packages/freedesktop.org.xml DESTINATION mime/packages)
endif (WIN32)

if (QUOTIENT_INSTALL_EXAMPLE)
    install(TARGETS qmc-example RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif (QUOTIENT_INSTALL_EXAMPLE)

if (UNIX AND NOT APPLE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Quotient.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif()

=== include/libQuotient/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# This CMakeLists file assumes that the library is installed to CMAKE_INSTALL_PREFIX
# and ignores the in-tree library code. You can use this to start work on your own client.

project(qmc-example CXX)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
endif(NOT WIN32)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
    set(CMAKE_INSTALL_LIBDIR ".")
endif()

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR ".")
endif()

if (NOT CMAKE_INSTALL_INCLUDEDIR)
    set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

set(CMAKE_CXX_STANDARD 14)

foreach (FLAG all "" pedantic extra error=return-type no-unused-parameter no-gnu-zero-variadic-macro-arguments)
    CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
    if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W${FLAG}")
    endif ()
endforeach ()

find_package(Qt5 5.6 REQUIRED Network Gui Multimedia)
get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)

find_package(Quotient REQUIRED)
get_filename_component(QMC_Prefix "${Quotient_DIR}/../.." ABSOLUTE)

message( STATUS "qmc-example configuration:" )
if (CMAKE_BUILD_TYPE)
    message( STATUS "  Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "  Compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "  Qt: ${Qt5_VERSION} at ${Qt5_Prefix}" )
message( STATUS "  Quotient: ${Quotient_VERSION} at ${QMC_Prefix}" )

set(example_SRCS qmc-example.cpp)

add_executable(qmc-example ${example_SRCS})
target_link_libraries(qmc-example Qt5::Core Quotient)

# Installation

install (TARGETS qmc-example RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== include/libQuotient/3rdparty/libQtOlm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(API_VERSION "0.1")
project(qtolm VERSION "${API_VERSION}.0" LANGUAGES CXX)

include(CheckCXXCompilerFlag)
if (NOT WIN32)
    include(GNUInstallDirs)
endif(NOT WIN32)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
    set(CMAKE_INSTALL_LIBDIR "lib")
endif()

if (NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR "bin")
endif()

if (NOT CMAKE_INSTALL_INCLUDEDIR)
    set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

foreach (FLAG all "" pedantic extra error=return-type no-unused-parameter no-gnu-zero-variadic-macro-arguments)
    CHECK_CXX_COMPILER_FLAG("-W${FLAG}" WARN_${FLAG}_SUPPORTED)
    if ( WARN_${FLAG}_SUPPORTED AND NOT CMAKE_CXX_FLAGS MATCHES "(^| )-W?${FLAG}($| )")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W${FLAG}")
    endif ()
endforeach ()

find_package(Qt5 5.9 REQUIRED Network)

# olm
find_package(Olm 3.0.0 REQUIRED)

message( STATUS )
message( STATUS "=============================================================================" )
message( STATUS "                       libqtolm Build Information" )
message( STATUS "=============================================================================" )
message( STATUS "Version: ${PROJECT_VERSION}, API version: ${API_VERSION}")
if (CMAKE_BUILD_TYPE)
    message( STATUS "Build type: ${CMAKE_BUILD_TYPE}")
endif(CMAKE_BUILD_TYPE)
message( STATUS "Using compiler: ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}" )
message( STATUS "Using Qt ${Qt5_VERSION}" )
message( STATUS "=============================================================================" )
message( STATUS )

# Set up source files
set(libqtolm_SRCS
    lib/account.cpp
    lib/account.h
    lib/groupsession.cpp
    lib/groupsession.h
    lib/message.cpp
    lib/message.h
    lib/pk.cpp
    lib/pk.h
    lib/session.cpp
    lib/session.h
    lib/utils.h
    lib/errors.h
)

add_library(QtOlm ${libqtolm_SRCS})
set_property(TARGET QtOlm PROPERTY VERSION "${PROJECT_VERSION}")
set_property(TARGET QtOlm PROPERTY SOVERSION ${API_VERSION} )
set_property(TARGET QtOlm PROPERTY
             INTERFACE_QtOlm_MAJOR_VERSION ${API_VERSION})
set_property(TARGET QtOlm APPEND PROPERTY
             COMPATIBLE_INTERFACE_STRING QtOlm_MAJOR_VERSION)

target_compile_features(QtOlm PUBLIC cxx_std_14)

target_include_directories(QtOlm PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
#    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
target_link_libraries(QtOlm Olm::Olm Qt5::Core Qt5::Network)

configure_file(QtOlm.pc.in ${CMAKE_CURRENT_BINARY_DIR}/QtOlm.pc @ONLY NEWLINE_STYLE UNIX)

# Installation

install(TARGETS QtOlm EXPORT QtOlmTargets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)
install(DIRECTORY lib/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.h")

include(CMakePackageConfigHelpers)
# NB: SameMajorVersion doesn't really work yet, as we're within 0.x trail.
# Maybe consider jumping the gun and releasing 1.0, as semver advises?
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/QtOlm/QtOlmConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
)

export(PACKAGE QtOlm)
export(EXPORT QtOlmTargets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/QtOlm/QtOlmTargets.cmake")
configure_file(cmake/QtOlmConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/QtOlm/QtOlmConfig.cmake"
    COPYONLY
)

set(ConfigFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/QtOlm")
install(EXPORT QtOlmTargets
        FILE QtOlmTargets.cmake DESTINATION ${ConfigFilesLocation})

install(FILES cmake/QtOlmConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/QtOlm/QtOlmConfigVersion.cmake"
    DESTINATION ${ConfigFilesLocation}
)
# Only available from CMake 3.7; reserved for future use
#install(EXPORT_ANDROID_MK QtOlmTargets DESTINATION share/ndk-modules)

if (WIN32)
    install(FILES mime/packages/freedesktop.org.xml DESTINATION mime/packages)
endif (WIN32)

if (UNIX AND NOT APPLE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/QtOlm.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif()

=== debian/changelog ===
spectral (0.0~2019.11.12+dfsg-2build1) focal; urgency=medium

  * Rebuild against new libcmark0.29.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 15 Feb 2020 19:31:27 +0100

spectral (0.0~2019.11.12+dfsg-2) unstable; urgency=medium

  * Add versioned dependencies for all the qml modules, based on a report
    from a user with older modules (but newer qt libraries) installed.
  * Fix FTBFS on big-endian machines such as s390x.

 -- Andres Salomon <dilinger@debian.org>  Fri, 07 Feb 2020 03:48:11 +0000

spectral (0.0~2019.11.12+dfsg-1) unstable; urgency=low

  * Initial release (closes: #941800).

 -- Andres Salomon <dilinger@debian.org>  Fri, 29 Nov 2019 21:48:50 +0000

=== debian/control ===
Source: spectral
Section: net
Priority: optional
Maintainer: Andres Salomon <dilinger@debian.org>
Build-Depends: debhelper (>= 12.0~),
               cmake,
               qtbase5-dev (>= 5.12),
               qtmultimedia5-dev,
               qtquickcontrols2-5-dev,
               libqt5svg5-dev,
               qt5keychain-dev,
               qtdeclarative5-dev,
               cmark,
               libcmark-dev,
               libolm-dev (>= 3.0)
Standards-Version: 4.4.1.1
Homepage: https://gitlab.com/b0/spectral

Package: spectral
Architecture: any
Depends: ${shlibs:Depends},
         qml-module-qtmultimedia (>= 5.12),
         qml-module-qtquick-controls2 (>= 5.12),
         qml-module-qtquick-layouts (>= 5.12),
         qml-module-qt-labs-settings (>= 5.12),
         qml-module-qt-labs-platform (>= 5.12),
         qml-module-qt-labs-qmlmodels (>= 5.12),
         qml-module-qtgraphicaleffects (>= 5.12),
         fonts-noto-color-emoji,
         ${misc:Depends}
Description: Glossy desktop chat client for the Matrix protocol
 Spectral is a glossy cross-platform QT-based chat client for the
 Matrix protocol. Matrix is an open, decentralized, federated
 communications protocol with support for chat rooms, IM, etc.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

get-orig-source:
	uscan  --force-download --repack --verbose

# TODO: Once the libquotient library stabilizes, we'll want to use a
# a shared library by setting USE_INTREE_LIBQMC to false. But we're
# not there yet.
#override_dh_auto_configure:
#	dh_auto_configure -- -DUSE_INTREE_LIBQMC=0

=== debian/watch ===
version=4
opts="dversionmangle=auto, repacksuffix=+dfsg" \
    https://gitlab.com/b0/spectral/-/tags \
    .*/spectral-(\d[\d.]*)\.tar\.gz

## spectral 0.0~2020.03.28

=== include/libQuotient/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,9 @@
 set(API_VERSION "0.6")
 project(Quotient VERSION "${API_VERSION}.0" LANGUAGES CXX)
 
-option(QUOTIENT_INSTALL_EXAMPLE "install qmc-example application" ON)
+option(${PROJECT_NAME}_INSTALL_TESTS "install quotest (former qmc-example) application" ON)
+# https://github.com/quotient-im/libQuotient/issues/369
+option(${PROJECT_NAME}_ENABLE_E2EE "end-to-end encryption (E2EE) support" OFF)
 
 include(CheckCXXCompilerFlag)
 if (NOT WIN32)
@@ -52,25 +54,29 @@
     endforeach ()
 endif()
 
-find_package(Qt5 5.9 REQUIRED Network Gui Multimedia)
+find_package(Qt5 5.9 REQUIRED Network Gui Multimedia Test)
 get_filename_component(Qt5_Prefix "${Qt5_DIR}/../../../.." ABSOLUTE)
 
-if ((NOT DEFINED USE_INTREE_LIBQOLM OR USE_INTREE_LIBQOLM)
-        AND EXISTS ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm/lib/utils.h)
-    add_subdirectory(3rdparty/libQtOlm EXCLUDE_FROM_ALL)
-    include_directories(3rdparty/libQtOlm)
-    if (NOT DEFINED USE_INTREE_LIBQOLM)
-        set (USE_INTREE_LIBQOLM 1)
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    if ((NOT DEFINED USE_INTREE_LIBQOLM OR USE_INTREE_LIBQOLM)
+            AND EXISTS ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm/lib/utils.h)
+        add_subdirectory(3rdparty/libQtOlm EXCLUDE_FROM_ALL)
+        include_directories(3rdparty/libQtOlm)
+        if (NOT DEFINED USE_INTREE_LIBQOLM)
+            set (USE_INTREE_LIBQOLM 1)
+        endif ()
     endif ()
-endif ()
-if (NOT USE_INTREE_LIBQOLM)
-    find_package(QtOlm 0.1.0 REQUIRED)
-    if (NOT QtOlm_FOUND)
-        message( WARNING "libQtOlm not found; configuration will most likely fail.")
-        message( WARNING "Make sure you have installed libQtOlm development files")
-        message( WARNING "as a package or checked out the library sources in lib/.")
-        message( WARNING "See also BUILDING.md")
+    if (NOT USE_INTREE_LIBQOLM)
+        find_package(QtOlm 0.1.0 REQUIRED)
+        if (NOT QtOlm_FOUND)
+            message( WARNING "libQtOlm not found; configuration will most likely fail.")
+            message( WARNING "Make sure you have installed libQtOlm development files")
+            message( WARNING "as a package or checked out the library sources in lib/.")
+            message( WARNING "See also BUILDING.md")
+        endif ()
     endif ()
+else ()
+    message( WARNING "End-to-end encryption (E2EE) support is turned off.")
 endif ()
 
 if (GTAD_PATH)
@@ -108,18 +114,20 @@
     endif ()
 endif ()
 find_package(Git)
-if (USE_INTREE_LIBQOLM)
-    message( STATUS "Using in-tree libQtOlm")
-    if (GIT_FOUND)
-        execute_process(COMMAND
-            "${GIT_EXECUTABLE}" rev-parse -q HEAD
-            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm
-            OUTPUT_VARIABLE QTOLM_GIT_SHA1
-            OUTPUT_STRIP_TRAILING_WHITESPACE)
-        message( STATUS "  Library git SHA1: ${QTOLM_GIT_SHA1}")
-    endif (GIT_FOUND)
-else ()
-    message( STATUS "Using libQtOlm ${QtOlm_VERSION} at ${QtOlm_DIR}")
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    if (USE_INTREE_LIBQOLM)
+        message( STATUS "Using in-tree libQtOlm")
+        if (GIT_FOUND)
+            execute_process(COMMAND
+                "${GIT_EXECUTABLE}" rev-parse -q HEAD
+                WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/3rdparty/libQtOlm
+                OUTPUT_VARIABLE QTOLM_GIT_SHA1
+                OUTPUT_STRIP_TRAILING_WHITESPACE)
+            message( STATUS "  Library git SHA1: ${QTOLM_GIT_SHA1}")
+        endif (GIT_FOUND)
+    else ()
+        message( STATUS "Using libQtOlm ${QtOlm_VERSION} at ${QtOlm_DIR}")
+    endif ()
 endif ()
 message( STATUS "=============================================================================" )
 message( STATUS )
@@ -129,6 +137,7 @@
     lib/networkaccessmanager.cpp
     lib/connectiondata.cpp
     lib/connection.cpp
+    lib/ssosession.cpp
     lib/logging.cpp
     lib/room.cpp
     lib/user.cpp
@@ -148,6 +157,7 @@
     lib/events/roomtombstoneevent.cpp
     lib/events/roommessageevent.cpp
     lib/events/roommemberevent.cpp
+    lib/events/roompowerlevelsevent.cpp
     lib/events/typingevent.cpp
     lib/events/receiptevent.cpp
     lib/events/reactionevent.cpp
@@ -158,6 +168,7 @@
     lib/events/directchatevent.cpp
     lib/events/encryptionevent.cpp
     lib/events/encryptedevent.cpp
+    lib/events/roomkeyevent.cpp
     lib/jobs/requestdata.cpp
     lib/jobs/basejob.cpp
     lib/jobs/syncjob.cpp
@@ -193,6 +204,7 @@
         ${ABS_GTAD_PATH} --config ${CSAPI_DIR}/gtad.yaml --out ${CSAPI_DIR}
             ${FULL_CSAPI_SRC_DIR}
             old_sync.yaml- room_initial_sync.yaml- # deprecated
+            search.yaml- # current GTAD is limited in handling move-only data
             sync.yaml- # we have a better handcrafted implementation
         WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/lib
         SOURCES ${FULL_CSAPI_DIR}/gtad.yaml
@@ -218,9 +230,12 @@
     endif()
 endif()
 
-set(example_SRCS examples/qmc-example.cpp)
+set(tests_SRCS tests/quotest.cpp)
 
 add_library(${PROJECT_NAME} ${lib_SRCS} ${api_SRCS})
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    target_compile_definitions(${PROJECT_NAME} PUBLIC ${PROJECT_NAME}_E2EE_ENABLED)
+endif()
 set_target_properties(${PROJECT_NAME} PROPERTIES
     VERSION "${PROJECT_VERSION}"
     SOVERSION ${API_VERSION}
@@ -235,11 +250,16 @@
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
 )
-target_link_libraries(${PROJECT_NAME} QtOlm Qt5::Core Qt5::Network Qt5::Gui Qt5::Multimedia)
-
-add_executable(qmc-example ${example_SRCS})
-target_link_libraries(qmc-example Qt5::Core Quotient)
-configure_file(Quotient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Quotient.pc @ONLY NEWLINE_STYLE UNIX)
+if (${PROJECT_NAME}_ENABLE_E2EE)
+    target_link_libraries(${PROJECT_NAME} QtOlm)
+endif()
+target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Network Qt5::Gui Qt5::Multimedia)
+
+set(TEST_BINARY quotest)
+add_executable(${TEST_BINARY} ${tests_SRCS})
+target_link_libraries(${TEST_BINARY} Qt5::Core Qt5::Test ${PROJECT_NAME})
+
+configure_file(${PROJECT_NAME}.pc.in ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc @ONLY NEWLINE_STYLE UNIX)
 
 # Installation
 
@@ -255,15 +275,15 @@
 # NB: SameMajorVersion doesn't really work yet, as we're within 0.x trail.
 # Maybe consider jumping the gun and releasing 1.0, as semver advises?
 write_basic_package_version_file(
-    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfigVersion.cmake"
+    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
     COMPATIBILITY SameMajorVersion
 )
 
 export(PACKAGE ${PROJECT_NAME})
 export(EXPORT ${PROJECT_NAME}Targets
        FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Targets.cmake")
-configure_file(cmake/QuotientConfig.cmake
-    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfig.cmake"
+configure_file(cmake/${PROJECT_NAME}Config.cmake
+    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake"
     COPYONLY
 )
 
@@ -271,21 +291,21 @@
 install(EXPORT ${PROJECT_NAME}Targets
         FILE ${PROJECT_NAME}Targets.cmake DESTINATION ${ConfigFilesLocation})
 
-install(FILES cmake/QuotientConfig.cmake
-    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/QuotientConfigVersion.cmake"
+install(FILES cmake/${PROJECT_NAME}Config.cmake
+    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
     DESTINATION ${ConfigFilesLocation}
 )
-install(EXPORT_ANDROID_MK QuotientTargets DESTINATION share/ndk-modules)
+install(EXPORT_ANDROID_MK ${PROJECT_NAME}Targets DESTINATION share/ndk-modules)
 
 if (WIN32)
     install(FILES mime/packages/freedesktop.org.xml DESTINATION mime/packages)
 endif (WIN32)
 
-if (QUOTIENT_INSTALL_EXAMPLE)
-    install(TARGETS qmc-example RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-endif (QUOTIENT_INSTALL_EXAMPLE)
+if (${PROJECT_NAME}_INSTALL_TESTS)
+    install(TARGETS ${TEST_BINARY} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+endif ()
 
 if (UNIX AND NOT APPLE)
-    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Quotient.pc
+    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc
             DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 endif()

=== debian/changelog ===
spectral (0.0~2020.03.28-1) unstable; urgency=low

  * New git snapshot release. 

 -- Andres Salomon <dilinger@debian.org>  Thu, 02 Apr 2020 21:29:47 +0000

spectral (0.0~2020.02.09-1) unstable; urgency=low

  * New git snapshot release.
  * Drop +dfsg from the version, re-introduce the app metadata, & update
    debian/copyright to document it. It was previously GFDL, now CC.
  * Document new upstream location.
  * Drop all the applied patches.

 -- Andres Salomon <dilinger@debian.org>  Fri, 06 Mar 2020 22:21:02 +0000

## spectral 0.0~git20210114.30028a2

=== CMakeLists.txt ===
--- 
+++ 
@@ -143,6 +143,8 @@
     src/spectraluser.h
     src/trayicon.h
     src/userlistmodel.h
+    src/publicroomlistmodel.h
+    src/userdirectorylistmodel.h
     src/utils.h
     src/accountlistmodel.cpp
     src/controller.cpp
@@ -155,6 +157,8 @@
     src/spectraluser.cpp
     src/trayicon.cpp
     src/userlistmodel.cpp
+    src/publicroomlistmodel.cpp
+    src/userdirectorylistmodel.cpp
     src/utils.cpp
     src/main.cpp
 )
@@ -238,8 +242,8 @@
     install(FILES linux/${IDENTIFIER}.appdata.xml
             DESTINATION  ${CMAKE_INSTALL_DATADIR}/metainfo
             )
-    file(GLOB spectral_icons icons/hicolor/*-apps-spectral.png)
+    file(GLOB spectral_icons icons/hicolor/*-apps-org.eu.encom.spectral.png)
     ecm_install_icons(ICONS ${spectral_icons}
-                      DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
-                      )
+            DESTINATION ${CMAKE_INSTALL_DATADIR}/icons
+    )
 endif(LINUX)

=== debian/changelog ===
spectral (0.0~git20210114.30028a2-3) unstable; urgency=low

  * Drop package building, replace with an empty Spectral package.
  * Depend on Neochat, which is maintained by KDE and is a fork of
    Spectral. We will remove Spectral from Debian after bookworm
    is released, as Spectral is no longer developed upstream.

 -- Andres Salomon <dilinger@debian.org>  Fri, 20 May 2022 16:28:58 +0000

spectral (0.0~git20210114.30028a2-2) unstable; urgency=medium

  * Drop some libQuotient residue from debian/copyright and debian/watch.
  * Revert 30028a27 from upstream git; it was causing hangs w/ 100% cpu
    when used with libQuotient 0.6.

 -- Andres Salomon <dilinger@debian.org>  Tue, 26 Jan 2021 00:30:45 +0000

spectral (0.0~git20210114.30028a2-1) unstable; urgency=low

  * New git snapshot release.
  * Break SortFilterProxyModel out of the source orig tarball, since
    it is coming from a different upstream. Uscan will now handle
    it automatically.
  * Stop building against the bundled libQuotient, and instead build
    against libquotient-dev in Debian. FTBFS fixes are included due to
    upstream using a libQuotient development snapshot.

 -- Andres Salomon <dilinger@debian.org>  Mon, 25 Jan 2021 07:34:05 +0000

=== debian/control ===
Source: spectral
Section: net
Priority: optional
Maintainer: Andres Salomon <dilinger@debian.org>
Build-Depends: debhelper (>= 12.0~),
Standards-Version: 4.4.1.1
Homepage: https://gitlab.com/b0/spectral

Package: spectral
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, neochat
Description: Transitional dummy package
 This is a transitional dummy package, it can be safely removed.
 Spectral is no longer developed, and Neochat replaces it.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_build:
	@echo hi mom!

override_dh_auto_configure:
#	test -d include/SortFilterProxyModel && rmdir include/SortFilterProxyModel
#	ln -s ../SortFilterProxyModel include/SortFilterProxyModel
#	dh_auto_configure -- -DUSE_INTREE_LIBQMC=0

#override_dh_clean:
#	dh_clean
#	rm -f include/SortFilterProxyModel || true
#	mkdir -p include/SortFilterProxyModel

#get-orig-source:
#	uscan  --force-download --repack --verbose

## spectral 1.0

=== DESCRIPTION ===
Package: spectral
Type: Package
Title: Common Methods of Spectral Data Analysis
Version: 1.0
Author: Martin Seilmayer
Maintainer: Martin Seilmayer <m.seilmayer@hzdr.de>
Description: Fourier and Hilbert transforms are utilized to perform several types
             of spectral analysis on the supplied data. Also fragmented and
             irregularly spaced data can be processed. A user friendly interface
             helps to interpret the results.
License: GPL-2
Depends: rasterImage, R (>= 2.15.0)
LazyData: TRUE
RoxygenNote: 5.0.1
LinkingTo: Rcpp
Imports: Rcpp
Packaged: 2016-09-13 07:20:39 UTC; ms5760
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2016-09-13 11:45:38

## spectral 1.0.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: spectral
 Type: Package
 Title: Common Methods of Spectral Data Analysis
-Version: 1.0
+Version: 1.0.1
 Author: Martin Seilmayer
 Maintainer: Martin Seilmayer <m.seilmayer@hzdr.de>
 Description: Fourier and Hilbert transforms are utilized to perform several types
@@ -14,7 +14,7 @@
 RoxygenNote: 5.0.1
 LinkingTo: Rcpp
 Imports: Rcpp
-Packaged: 2016-09-13 07:20:39 UTC; ms5760
+Packaged: 2016-09-15 10:44:25 UTC; ms5760
 NeedsCompilation: yes
 Repository: CRAN
-Date/Publication: 2016-09-13 11:45:38
+Date/Publication: 2016-09-15 15:46:39

## spectral 1.3

=== DESCRIPTION ===
Package: spectral
Type: Package
Title: Common Methods of Spectral Data Analysis
Version: 1.3
Author: Martin Seilmayer
Maintainer: Martin Seilmayer <m.seilmayer@hzdr.de>
Description: Fourier and Hilbert transforms are utilized to perform several
    types of spectral analysis on the supplied data. Fragmented and irregularly
    spaced data can be processed in terms of Lomb-Scargle method. Both,
    FFT as well as LOMB methods take multivariate data. A user friendly
    interface helps to interpret the results.
License: GPL-2
Depends: rasterImage,lattice, R (>= 2.15.0)
LazyData: TRUE
RoxygenNote: 6.1.1
NeedsCompilation: no
Packaged: 2019-06-03 06:46:04 UTC; martinseilmayer
Repository: CRAN
Date/Publication: 2019-06-03 11:30:07 UTC

## spectral 2.0

=== DESCRIPTION ===
Package: spectral
Type: Package
Title: Common Methods of Spectral Data Analysis
Version: 2.0
Author: Martin Seilmayer
Maintainer: Martin Seilmayer <martin.seilmayer@gmail.com>
Description: On discrete data spectral analysis is performed by Fourier and Hilbert
    transforms as well as with model based analysis called Lomb-Scargle method.
    Fragmented and irregularly spaced data can be processed in almost all methods. Both,
    FFT as well as LOMB methods take multivariate data and return standardized PSD. 
    For didactic reasons an analytical approach for deconvolution of noise spectra and 
    sampling function is provided.
    A user friendly interface helps to interpret the results.
License: GPL-2
Depends: rasterImage,lattice,RhpcBLASctl,pbapply, R (>= 3.5.0)
LazyData: FALSE
RoxygenNote: 7.1.0
NeedsCompilation: no
Packaged: 2021-03-28 17:29:07 UTC; martinseilmayer
Repository: CRAN
Date/Publication: 2021-03-29 09:30:02 UTC
